/*
 * .cgi:  CGI 
 * $Revision: 1.3.2.1 $
 * $Date: 1999-01-28 23:00:42+09 $
 * Copyright 1998 SUZUKI, Mitsuhiro All Rights Reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#if CLOCK
#include <sys/resource.h>
#endif
#include <fcntl.h>

#include "gd.h"
#include "gdfonts.h"
#include "gdfontl.h"

#include "mytypes.h"
#include "lock.h"

#include "colors.h"

#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif

#define SMALL_BUFFER_SIZE 256

#ifndef WIDTH 
#define WIDTH 82
#endif

#ifndef HEIGHT
#define HEIGHT 20
#endif

#ifndef BACKGROUND_COLOR
#define BACKGROUND_COLOR 	WHITE
#endif

#ifndef FOREGROUND_COLOR
#define FOREGROUND_COLOR	BLACK
#endif

#ifndef EMERGENCY_COLOR
#define EMERGENCY_COLOR		RED
#endif

#ifndef CHECK_IP
#define CHECK_IP 1
#endif

#ifndef WRITE_ACCESS_LOG
#define WRITE_ACCESS_LOG 0
#endif

#ifndef USE_SMTP
#define USE_SMTP 0
#endif
#ifndef CLOCK
#define CLOCK 0
#endif

#define ESC (0x1b)
#define ASCII 0
#define KANJI 1

#ifndef DRAW_FACE
#define DRAW_FACE 1
#endif

#ifndef CONGRATULATORY_MAIL
#define CONGRATULATORY_MAIL 0
#endif
#ifndef CONGRATULATORY_COUNT
#define CONGRATULATORY_COUNT 1000
#endif

#if DRAW_FACE
char *g_face = FACE_NORMAL;
#endif 

struct timeval rt_start;
#if CLOCK
#define TIMEVAL_DOUBLE(time_val) ((time_val).tv_sec+(time_val).tv_usec*1.0e-6)
#define TIMEVAL_DIFF(val2, val1) (((val2).tv_sec-(val1).tv_sec)+((val2).tv_usec-(val1).tv_usec)*1.0e-6)
#endif /* CLOCK */

void perror_gif(im, msg, color)
	gdImagePtr im;
	CONST char *msg;
	int color;
{
	gdImageString(im, gdFontSmall, 0, 0, msg, color);
	gdImageGif(im, stdout);
}
/*
 * int2ascii : 
 */
void int2ascii(str, count)
	char str[9];
	int count;
{
	int i;
	str[8] = '\0';
	for (i = 7; i >= 0; i--, count /= 10) {
		str[i] = '0'+count%10;
	}
}
void int2stream(fp, count)
	FILE *fp;
	int count;
{
	char str[9];
	int2ascii(str, count);
	fputs(str, fp);
}
#if CHECK_IP
int check_ip()
{
	int fd_ip;
	char buf[16];
	char *forwarded, *remote_addr;
	int read_count, remote_addr_len;
		
	if ((forwarded = getenv("HTTP_FORWARDED")) == NULL) {
		if ((remote_addr = getenv("REMOTE_ADDR")) == NULL){
			return ERR;
		}
	} else {
		if ((remote_addr = strstr(forwarded, " for ")) != NULL) {
			remote_addr += strlen(" for ");
		} else {
			return ERR;
		}
	}
	if ((fd_ip = open(IP_FILE, O_RDONLY)) == ERR) {
		return ERR;
	}
	if ((read_count = read(fd_ip, buf, 15)) == ERR) {
		return ERR;
	}
	buf[read_count] = '\0';
	if (close (fd_ip) == ERR) {
		return ERR;
	}
	if (strcmp(buf, remote_addr) == 0) {
		return 0;
	}
	
	if ((fd_ip = LockFile(IP_FILE, TRUE, FALSE)) == ERR) {
		return ERR;
	}
	remote_addr_len = strlen(remote_addr);
	if (write(fd_ip, remote_addr, remote_addr_len) < remote_addr_len) {
		UnlockFile(fd_ip);
		return ERR;
	}
	UnlockFile(fd_ip);
	return 1;
}
#endif /* CHECK_IP */
/*
 * IPtoHostName : IP հ
 */
#if CONGRATULATORY_MAIL || WRITE_ACCESS_LOG
void IPtoHostName(dst, ipaddr)
	char *dst;
	CONST char *ipaddr;
{
	struct hostent *hent;
	unsigned long sin_addr;
	
	sin_addr = inet_addr(ipaddr);
	hent = gethostbyaddr((char *)&sin_addr,
						 sizeof(sin_addr), AF_INET);
	if (hent == NULL) {
		strcpy(dst, ipaddr);
		return;
	}
	strcpy(dst, hent->h_name);
}
#endif /* CONGRATULATORY_MAIL || WRITE_ACCESS_LOG */
/*
 * anaume : ᡼ƥץ졼Ȥη
 */
#if CONGRATULATORY_MAIL
void anaume(val, fp_mail)
	CONST char *val;
	FILE *fp_mail;
{
	if (strcmp(val, "SERVER_NAME") == 0) {
		/* CGI ưƤ륵 */
		char *szServer = NULL;
		szServer = getenv("SERVER_NAME");
		if (szServer != NULL) {
			fputs(szServer, fp_mail);
		}
	} else if (strcmp(val, "REMOTE_ADDR") == 0) {
		/* ⡼ȥɥ쥹(IP) */
		char *szRemoteAddr = NULL;
		szRemoteAddr = getenv("REMOTE_ADDR");
		if (szRemoteAddr != NULL) {
			fputs(szRemoteAddr, fp_mail);
		}
	} else if (strcmp(val, "REMOTE_HOST") == 0) {
		/* ⡼ȥۥ̾ */
		char *szRemoteHost = NULL;
		szRemoteHost = getenv("REMOTE_HOST");
		if (szRemoteHost != NULL) {
			fputs(szRemoteHost, fp_mail);
		} else {
			char *szRemoteAddr = NULL;
			char host_name[256];
			szRemoteAddr = getenv("REMOTE_ADDR");
			if (szRemoteAddr != NULL) {
				IPtoHostName(host_name, szRemoteAddr);
				fputs(host_name, fp_mail);
			}
		}
	}
}
/*
 * mail_contents : ᡼ʸ
 */
void mail_contents(count, fp_mail)
	int count;
	FILE *fp_mail;
{
	FILE *fp_mail_template;
	int mode = ASCII;
	int c;
	
	fp_mail_template = fopen(MAIL_TEMPLATE_FILE, "r");
	if (fp_mail_template == NULL) {
		return ;
	}
	while ((c = getc(fp_mail_template)) != EOF) {
		char word[64];
		int i = 0;
		
		if (c == ESC) {
			int d, f;
			d = getc(fp_mail_template);
			f = getc(fp_mail_template);
			if (d == '$' && f == 'B') {
				mode = KANJI;
			}else if (d == '(' && f == 'B') {
				mode = ASCII;
			}
			putc(c, fp_mail);
			putc(d, fp_mail);
			putc(f, fp_mail);
			continue;
		}
		if (c != '%' || mode == KANJI) {
			putc(c, fp_mail);
			continue;
		}
		do {
			word[i++] = c = getc(fp_mail_template);
		} while((isalnum(c) || c == '_') && i < sizeof word);
		word[i-1] = '\0';
		
		if (strcmp(word, "count") == 0) {
			int2stream(fp_mail, count);
		} else {
			anaume(word, fp_mail);
		}
		fputc(c, fp_mail);
	}

}
/*
 * print2mail : fp إ᡼ʸ
 */
void print2mail(fp_mail, count)
	FILE *fp_mail;
	int count;
{
	/* Mail إåν */
	fprintf(fp_mail, "Subject: Congratulation !! %8d access.", count);
	fprintf(fp_mail, "From: Keiko <%s>\n", ADMIN_EMAIL);
	fputs("Mime-Version: 1.0\n", fp_mail);
	fputs("Content-Type: text/plain; charset=iso-2022-jp\n", fp_mail);
	fputs("\n", fp_mail);
	
	mail_contents(count, fp_mail);
}
/*
 * SendMail : ᡼򤷤ơ᡼򤹤롣
 */
BOOL SendMail(count)
	int count;
{
	FILE *mail_pipe;
	char buff[SMALL_BUFFER_SIZE];
		
#if USE_SMTP
	sprintf(buff, "%s %s", SENDMAIL_PATH, ADMIN_EMAIL);
	mail_pipe = popen(buff, "w");
#else /* USE_SMTP */
	mail_pipe = write_to(ADMIN_EMAIL, ADMIN_EMAIL, MAIL_SRV);
#endif /* USE_SMTP */
	if (mail_pipe == NULL) {
		return FALSE;
	}
	print2mail(mail_pipe, count);
		
#if USE_SMTP
	pclose(mail_pipe);
#else /* USE_SMTP */
	if (quit_writting(mail_pipe) != 0)
		return FALSE;
#endif /* USE_SMTP */

	return TRUE;
}
#endif /* CONGRATULATORY_MAIL */
/*
 * increment: 󥿤 add(=0 or 1) 䤹
 */
int increment(count_string, add)
	char *count_string;
	int add;
{
	int fd_count;
	int read_count, count_string_len;
	int count;
	
	if ((fd_count = WRLockFile(COUNT_FILE)) == ERR) {
		return ERR;
	}
	if ((read_count = read(fd_count, count_string, 16)) == ERR) {
		return ERR;
	}
	count_string[read_count] = '\0';
	count = atoi(count_string)+add;
	if (count%CONGRATULATORY_COUNT == 0 && add != 0) {
#if CONGRATULATORY_MAIL
		if (fork() != 0) {
			SendMail(count);
			exit(EXIT_SUCCESS);
		}
#endif /* CONGRATULATORY_MAIL */
		
#if DRAW_FACE		
		g_face = FACE_SMILE;
#endif /* DRAW_FACE */
	}
	int2ascii(count_string, count);
	count_string_len = strlen(count_string);
	if (lseek(fd_count, 0, SEEK_SET) == ERR) {
		UnlockFile(fd_count);
		return ERR;
	}
	if (write(fd_count, count_string, count_string_len+1)
		< count_string_len+1) {
		UnlockFile(fd_count);
		return ERR;
	}
	UnlockFile(fd_count);
	
	return count_string_len;
}
/*
 * draw_digits : gd ǿ
 */
int draw_digits(im_out, count_string, count_string_len)
	gdImagePtr im_out;
	char *count_string;
	int count_string_len;
{
	gdImagePtr im_canvas;
	int background_color, foreground_color;
	int canvas_width = 0, canvas_height = 0;
	int str_area_width = 0, str_width = 0;
	int str_x = LEFT_MARGIN;
#if DRAW_FACE
	gdImagePtr im_face = NULL;
	FILE *fp_face;
	if ((fp_face = fopen(g_face, "rb")) != NULL) {
		im_face = gdImageCreateFromGif(fp_face);
		fclose(fp_face);
		str_x += canvas_width = gdImageSX(im_face);
	}
#endif /* DRAW_FACE */
	str_width = count_string_len*gdFontLarge->w;
	canvas_width += str_area_width = str_width+LEFT_MARGIN*2;
	canvas_height = gdFontLarge->h+TOP_MARGIN*2;
	im_canvas = gdImageCreate(canvas_width, canvas_height);
	if (im_canvas == NULL) {
		return FALSE;
	}
	background_color = gdImageColorAllocate(im_canvas, BACKGROUND_COLOR);
	foreground_color = gdImageColorAllocate(im_canvas, FOREGROUND_COLOR);
#if DRAW_FACE
	if (im_face != NULL) {
		gdImageCopyResized(im_canvas, im_face,
						   0, 0,
						   0, 0,
						   canvas_width-str_area_width, canvas_height,
						   gdImageSX(im_face), gdImageSY(im_face));
		gdImageDestroy(im_face);
	}
#endif /* DRAW_FACE */
	gdImageString(im_canvas, gdFontLarge,
				  str_x, TOP_MARGIN,
				  count_string, foreground_color);
	gdImageCopyResized(im_out, im_canvas, 
						0, 0, 
						0, 0,
						WIDTH, HEIGHT,
						canvas_width, canvas_height);
	gdImageGif(im_out, stdout);
	fflush(stdout);
	
	gdImageDestroy(im_canvas);

	return TRUE;
}
#if WRITE_ACCESS_LOG
void append_access_log(count_string)
	char *count_string;
{
	char date[SMALL_BUFFER_SIZE];
	char *forwarded, *ip, *host, *user_agent, *referer;
	char buff[SMALL_BUFFER_SIZE];
	FILE *fp;
	int fd;
#if CLOCK
	struct rusage res_usage;
	struct timeval rt_end;
#endif /* CLOCK */
	if ((fd = LockFile(ACCESS_LOG, FALSE, FALSE)) == ERR) {
		return;
	}
	if ((fp = fdopen(fd, "a")) == NULL) {
		return;
	}
	strftime(date, SMALL_BUFFER_SIZE, "%c",
				 localtime(&(rt_start.tv_sec)));

	if ((forwarded = getenv("HTTP_FORWARDED")) == NULL) {
		if ((ip = getenv("REMOTE_ADDR")) == NULL) {
			ip = "Unknown(IP)";
			host = "Unknown(Host Name)";
		} else if ((host = getenv("REMOTE_HOST")) == NULL) {
			IPtoHostName(buff, ip);
			host = buff;
		}
	} else {
		if ((ip = strstr(forwarded, " for ")) != NULL) {
			ip += strlen(" for ");
			IPtoHostName(buff, ip);
			host = buff;
		} else {
			ip = "Unknown(IP)";
			host = "Unknown(Host Name)";
		}
	}
	if ((user_agent = getenv("HTTP_USER_AGENT")) == NULL) {
		user_agent = "Unknown(User Agent)";
	}
	if ((referer = getenv("HTTP_REFERER")) == NULL) {
		referer = "Unknown(Referer)";
	}
	fprintf(fp, "%s, %s, %s, %s, %s, %s",
			count_string, referer, date, ip, host, user_agent);
#if CLOCK
	getrusage(RUSAGE_SELF, &res_usage);
	gettimeofday(&rt_end, NULL);
	fprintf(fp, ", %f, %f, %f",
			TIMEVAL_DIFF(rt_end, rt_start),
			TIMEVAL_DOUBLE(res_usage.ru_utime),
			TIMEVAL_DOUBLE(res_usage.ru_stime));
#endif /* CLOCK */
	putc('\n', fp);
	fclose(fp);
	UnlockFile(fd);
}
#endif /* WRITE_ACCESS_LOG */
int main(argc, argv)
	int argc;
	char *argv[];
{
	gdImagePtr im_out;
	int background_color, emergency_color;
	char count_string[16+1];
	int count_string_len;
	int add = 1;
	gettimeofday(&rt_start, NULL);
	fputs("Content-type: image/gif\n\n", stdout);
	im_out = gdImageCreate(WIDTH, HEIGHT);
	if (im_out == NULL) {
		fputs("Error: GD gdImageCreate()\n", stderr);
		return 1;
	}
	background_color = gdImageColorAllocate(im_out, BACKGROUND_COLOR);
	emergency_color = gdImageColorAllocate(im_out, EMERGENCY_COLOR);
	
#if CHECK_IP
	if ((add = check_ip()) == ERR) {
		perror_gif(im_out, "Error: Checking IP address", emergency_color);
		gdImageDestroy(im_out);
		return 1;
	}
#endif /* CHECK_IP */

	if ((count_string_len = increment(count_string, add)) == ERR) {
		perror_gif(im_out, "Error: Adding Counter.", emergency_color);
		gdImageDestroy(im_out);
		return 1;
	}
	if (!draw_digits(im_out, count_string, count_string_len)) {
		perror_gif(im_out, "Error: Drawing Digits.", emergency_color);
		gdImageDestroy(im_out);
		return 1;
	}
	gdImageDestroy(im_out);
#if WRITE_ACCESS_LOG	
	append_access_log(count_string);
#endif /* WRITE_ACCESS_LOG */

	return 0;
}
